import { Body, JsonController, Post, QueryParam, Res } from 'routing-controllers';
import { OpenAPI } from 'routing-controllers-openapi';
import { Runner } from '../models/Runner';
import { PdfCreator } from '../PdfCreator';

@JsonController()
export class PdfController {
    private pdf: PdfCreator;
    constructor() {
        this.pdf = new PdfCreator();
    }

    @Post('/contracts')
    @OpenAPI({ description: "Generate Sponsoring contract pdfs from runner objects." })
    async generateContracts(@Body({ validate: true }) runners: Runner | Runner[], @Res() res: any, @QueryParam("locale") locale: string) {
        if (!Array.isArray(runners)) {
            runners = [runners]
        }
        const contracts = await this.pdf.generateSponsoringContract(runners, locale);
        res.setHeader('content-type', 'application/pdf');
        return contracts;
    }
}
